#include <OS.h>
#include <Roster.h>
#include <Message.h>
#include <stdlib.h>
#include <stdio.h>
//#include "Scripting.h"
#undef max
#undef min
extern "C" {
#define __STDC__
#include "error.h"
//#undef __cplusplus
#include "_scm.h"
//#define __cplusplus
};
#include "bmessage.h"

const false = 0;
const true = 1;

#if 0
static SCM *
alloc_aligned (wantsize, who)
     int wantsize;
     char *who;
{
  int size = wantsize + 7;
  SCM *p = (SCM *) scm_must_malloc (size, who);

  /* Adjust it so it's aligned on an eight-byte boundary.  */
  p = (SCM *) (((SCM) p + 7) & ~7);

  return p;
}
#endif


SCM_PROC (s_make_bmessage, "make-bmessage", 1, 0, 0, scm_make_bmessage);

SCM 
scm_make_bmessage (
	SCM scmwhat)
{
	long what;
	SCM s;
//	SCM_NEWCELL (s);

//    SCM_ASSERT (SCM_NUMBERP (scmwhat), scmwhat, SCM_ARG1, s_make_bmessage);
	what = scm_num2long(scmwhat, (char *)SCM_ARG1, s_make_bmessage); //SCM_INUM (verb);	


#if 0
	BMessage *msg = (BMessage *) alloc_aligned(sizeof(BMessage), s_make_bmessage);
	// call constructor
	msg->BMessage(what);
//  SCM_SETCHARS (s, (char *) (msg + 1));
//  SCM_SETLENGTH (s, len, scm_tc7_string);
//  SCM_REALLOW_INTS;
//  SCM_CHARS (s)[len] = 0;
#else
	BMessage *msg = new BMessage(what);
#endif

	return (SCM)msg;
}


SCM_PROC (s_delete_bmessage, "delete-bmessage", 1, 0, 0, scm_delete_bmessage);

SCM 
scm_delete_bmessage (
	SCM scmmsg)
{
	BMessage *msg = (BMessage *)scmmsg;

	delete msg;
	
	return SCM_BOOL_T;
}
	
	static
	bool GetApp(char *name, BMessenger &outMsgr)
	{
		BList teamList;
		be_roster->GetAppList(&teamList);
		bool gotIt = false;
		for (int ix=teamList.CountItems()-1; ix>=0; ix--) {
			team_id team = (team_id)teamList.ItemAt(ix);
			thread_info info;
			get_nth_thread_info(team, 0, &info);
			if (!strcmp(info.name, name)) {
				team_info tm_info;
				get_team_info(team, &tm_info);
				BMessenger ret(0, team);
				outMsgr = ret;
				gotIt = true;
				break;
			}
		}
		if (!gotIt) {
			fprintf(stderr, "Can't find app: %s\n", name);
			return false;
		}
		return true;
	}

SCM_PROC (s_send_bmessage, "send-bmessage", 2, 0, 0, scm_send_bmessage);

SCM 
scm_send_bmessage (
	SCM scmapp,
	SCM scmmsg)
{
	char *appstr;
	BMessage *reply = 0;
	BMessenger msgr;
	BMessage *msg = (BMessage *)scmmsg;

	SCM_ASSERT (SCM_NIMP (scmapp) && SCM_ROSTRINGP (scmapp), scmapp,
	      SCM_ARG1, s_send_bmessage);
	appstr = SCM_CHARS (scmapp);

	SCM_DEFER_INTS;

	// get application
	if (! GetApp(appstr, msgr)) {
		return SCM_BOOL_F;
	}

//	fprintf(stderr, "SendMessage\n");
	if (msgr.SendMessage(msg, &reply)) {
		SCM_ALLOW_INTS;
		return SCM_BOOL_F;
	}

	SCM_ALLOW_INTS;
	
	return SCM_BOOL_T;
}

SCM_PROC (s_add_bmessage_data, "add-bmessage-data!", 4, 0, 0,
	 scm_add_bmessage_data);

SCM 
scm_add_bmessage_data (
	SCM scmmsg,
	SCM scmname,
	SCM scmtype,
	SCM scmdata)
{
	BMessage *msg = (BMessage *)scmmsg;

	SCM_ASSERT (SCM_NIMP (scmname) && SCM_ROSTRINGP (scmname), scmname,
	      SCM_ARG2, s_add_bmessage_data);
	char *namestr = SCM_CHARS (scmname);

	long type = scm_num2long(scmtype, (char *)SCM_ARG3, s_add_bmessage_data);

	SCM_ASSERT (SCM_NIMP (scmdata) && SCM_ROSTRINGP (scmdata), scmdata,
	      SCM_ARG4, s_add_bmessage_data);
	char *datastr = SCM_CHARS (scmdata);
	long datalen = scm_string_length (scmdata);

//	fprintf(stderr, "add-bmessage-data! {\n");
	SCM_DEFER_INTS;
	msg->AddData(namestr, type, datastr, datalen);
	SCM_ALLOW_INTS;
//	fprintf(stderr, "} add-bmessage-data!\n");
	
	return SCM_BOOL_T;
}

void
scm_init_bmessage ()
{
#include "bmessage.x"
}
