(define (string->long s)
	(+
		(ash (char->integer (string-ref s 0)) 24)
		(ash (char->integer (string-ref s 1)) 16)
		(ash (char->integer (string-ref s 2)) 8)
		(char->integer (string-ref s 3))
	))
	
(define (long->string n)
	(let ((str (make-string 4)))
		(string-set! str 0 (integer->char (ash n -24)))
		(string-set! str 1 (integer->char (ash n -16)))
		(string-set! str 2 (integer->char (ash n -8)))
		(string-set! str 3 (integer->char n))
		str))

(define Quit (string->long "_QRQ"))
(define Open (string->long "ssm!"))
(define Save (string->long "sav!"))
(define Close (string->long "bye!"))
(define Set (string->long "set!"))
(define Get (string->long "get?"))
(define Make (string->long "mak+"))
(define Delete (string->long "del-"))
(define Count (string->long "num?"))
(define Reply (string->long "done"))

(define formDirect (long->string 0))
(define formFirst (long->string 1))
(define formLast (long->string 2))
(define formIndex (long->string 3))
(define formReverseIndex (long->string 4))
(define formIndexRange (long->string 5))
(define formID (long->string 6))
(define formName (long->string 7))
(define formUser (long->string 8))
	
(define B_STRING_TYPE (string->long "CSTR"))
(define B_LONG_TYPE (string->long "LONG"))
(define PROPERTY_TYPE (string->long "prop"))

(define (make-prop-name name)
	(let ((str (make-string 64 #\null)))
		(do ((i 0 (+ i 1)))
			((or (>= i (string-length name)) (>= i 64)) str)
			(string-set! str i (string-ref name i)))
		))

(define (make-direct-prop str)
	(string-append
		(make-prop-name str) formDirect))
		
(define (make-index-prop str inx)
	(string-append
		(make-prop-name str)
		formIndex
		(long->string inx)))

(define (add-bmessage-long! msg name long)
	(add-bmessage-data! msg name B_LONG_TYPE (long->string long)))
(define (add-bmessage-longs! msg name data)
	(do ((data data (cdr data)))
		((null? data) )
		(add-bmessage-long! msg name (car data))))
		
